#ifndef CONSOLELOGITEM_H
#define CONSOLELOGITEM_H
#include <QListWidgetItem>
#include <QString>
#include "guiproject.h"

class ConsoleLogItem : public QListWidgetItem
{
private:
    guiProject * prj;
    QString m_file;
    QString m_function;
    /*
     * Por la forma de codificación de los nombres de los callbacks, cuando se detecta un error en una
     * función puede ser un callback que se divida en tres partes <dlgName>_<Ctrl>_<CallBack> o
     * <dlgName>_<CallBack>. Utilizando estas variables, cuando se asigna una función como base del error
     * se obtienen las 3 partes indicadas anteriormente
     */
    QString m_dlgName;
    QString m_ctrlName;
    QString m_cbName;

    int m_line;
    int m_col;
public:
    ConsoleLogItem(guiProject * prj, QListWidget *parent = nullptr);
    ConsoleLogItem(guiProject * prj, const QString &text, QListWidget *parent = nullptr);
    ConsoleLogItem(guiProject * prj,const QIcon &icon, const QString &text, QListWidget *parent = nullptr);
    guiProject * project(void){
        return this->prj;
    }
    void setFile(QString f){
        this->m_file = f;
    }
    QString file(void){
        return this->m_file;
    }
    void setFunction(QString f){
        this->m_function = f;
        this->m_dlgName = "";
        this->m_cbName = "";
        this->m_ctrlName = "";
        QStringList partes=f.split("_");
        if(partes.count()==3){
            m_dlgName = partes[0];
            m_ctrlName = partes[1];
            m_cbName = partes[2];
          }
        else if(partes.count() == 2){
            m_dlgName = partes[0];
            m_cbName = partes[1];
          }
    }
    QString dlgName(void){
      return this->m_dlgName;
    }
    QString ctrlName(void){
      return this->m_ctrlName;
    }
    QString cbName(void){
      return this->m_cbName;
    }

    QString function(void){
        return this->m_function;
    }
    void setLine(int l){
        this->m_line = l;
    }
    int line(void){
        return this->m_line;
    }
    void setColumn(int c){
        this->m_col = c;
    }
    int column(void){
        return this->m_col;
    }
};

#endif // CONSOLELOGITEM_H
