/****************************************************************************
Copyright 2015-2020, Enrique Sergio Burgos

This file is part of GUI Editor for Octave.

GUI Editor for Octave is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GUI Editor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GUI Editor.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************************/
#include "dlgitemedit.h"
#include "ui_dlgitemedit.h"

dlgItemEdit::dlgItemEdit(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::dlgItemEdit)
{
    ui->setupUi(this);
}

dlgItemEdit::~dlgItemEdit()
{
    delete ui;
}

void dlgItemEdit::on_btnAdd_clicked()
{
    ui->listItem->addItem(ui->leNewVal->text());
}

void dlgItemEdit::on_btnDel_clicked()
{
    delete ui->listItem->takeItem(ui->listItem->currentRow());

}

void dlgItemEdit::on_btnUp_clicked()
{
    QListWidgetItem * currentItem;
    int currentRow = ui->listItem->currentRow();
    if (currentRow > 0)
    {
      currentItem = ui->listItem->takeItem(currentRow);
      ui->listItem->insertItem(currentRow - 1, currentItem);
      ui->listItem->setCurrentRow(currentRow - 1);
    }
}

void dlgItemEdit::on_btnDown_clicked()
{
    QListWidgetItem * currentItem;
    int currentRow = ui->listItem->currentRow();
    if (currentRow < ui->listItem->count()-1)
    {
      currentItem = ui->listItem->takeItem(currentRow);
      ui->listItem->insertItem(currentRow + 1, currentItem);
      ui->listItem->setCurrentRow(currentRow + 1);
    }
}

void dlgItemEdit::on_btnAceptar_clicked()
{

}
