/****************************************************************************
Copyright 2015-2020, Enrique Sergio Burgos

This file is part of GUI Editor for Octave.

GUI Editor for Octave is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GUI Editor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GUI Editor.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************************/
#ifndef dlgPkgGen_H
#define dlgPkgGen_H

#include <QDialog>
#include <QProcess>

namespace Ui {
class dlgPkgGen;
}

class dlgPkgGen : public QDialog
{
    Q_OBJECT

public:
    explicit dlgPkgGen(QWidget *parent = 0);
    ~dlgPkgGen();
    void startGen(QString path, QString pkgName);
private:
    Ui::dlgPkgGen *ui;
    QProcess *gzip;
    QProcess *tar;
    QString path;
    QString pkgName;
protected slots:
    void tarStarted();
    void tarFinished(int exitCode, QProcess::ExitStatus exitStatus);
    void tarReadyReadOutput();
    void tarReadyReadError();
    void gzipStarted();
    void gzipFinished(int exitCode, QProcess::ExitStatus exitStatus);
    void gzipReadyReadOutput();
    void gzipReadyReadError();

private slots:
    void on_btnOpen_clicked();
    void on_btnClose_clicked();
};

#endif // dlgPkgGen_H
