/****************************************************************************
Copyright 2015-2020, Enrique Sergio Burgos

This file is part of GUI Editor for Octave.

GUI Editor for Octave is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GUI Editor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GUI Editor.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************************/
#ifndef guiEditorVersion_h
#define guiEditorVersion_h

const char __fullDate__[] =
    {
        // YYYY year
        __DATE__[7], __DATE__[8], __DATE__[9], __DATE__[10],

        // First month letter, Oct Nov Dec = '1' otherwise '0'
        (__DATE__[0] == 'O' || __DATE__[0] == 'N' || __DATE__[0] == 'D') ? '1' : '0',

        // Second month letter
        (__DATE__[0] == 'J') ? ( (__DATE__[1] == 'a') ? '1' :       // Jan, Jun or Jul
                                    ((__DATE__[2] == 'n') ? '6' : '7') ) :
            (__DATE__[0] == 'F') ? '2' :                                // Feb
            (__DATE__[0] == 'M') ? (__DATE__[2] == 'r') ? '3' : '5' :   // Mar or May
            (__DATE__[0] == 'A') ? (__DATE__[1] == 'p') ? '4' : '8' :   // Apr or Aug
            (__DATE__[0] == 'S') ? '9' :                                // Sep
            (__DATE__[0] == 'O') ? '0' :                                // Oct
            (__DATE__[0] == 'N') ? '1' :                                // Nov
            (__DATE__[0] == 'D') ? '2' :                                // Dec
            0,

        // First day letter, replace space with digit
        __DATE__[4]==' ' ? '0' : __DATE__[4],

        // Second day letter
        __DATE__[5],

        '\0'
};

#define guiVERSION "Ver: 3.0.0"
#define guiBUILD __DATE__
#define guiBuildDate __fullDate__

#endif
