## -*- texinfo -*-
## @deftypefn  {} {} dummy()
##
## This is a dummy function documentation. This file have a lot functions
## and each one have a little documentation. This text is to avoid a warning when
## install this file as part of package.
## @end deftypefn
##
## Set the graphics toolkit and force read this file as script file (not a function file).
##
graphics_toolkit qt;
##


##
##
## Begin callbacks definitions 
##

## @deftypefn  {} {} edIp1_doIt (@var{src}, @var{data}, @var{selIpAddr})
##
## Define a callback for default action of edIp1 control.
##
## @end deftypefn
function edIp1_doIt(src, data, selIpAddr)

% This code will be executed when the control lost focus and text has 
% been changed or when press the "enter" key.
% As default, all events are deactivated, to activate must set the
% propertie 'have callback' from the properties editor
[ipHigh, ok] = str2num(get(selIpAddr.edIp1, 'String'));
if (ok)
  ipHigh = int32(ipHigh);
endif

if ((!ok) || (ipHigh < 1) || (ipHigh > 254)) 
  msgbox('The first part of address may be incorrect', 'Warning');
endif
end

## @deftypefn  {} {} edIp2_doIt (@var{src}, @var{data}, @var{selIpAddr})
##
## Define a callback for default action of edIp2 control.
##
## @end deftypefn
function edIp2_doIt(src, data, selIpAddr)

% This code will be executed when the control lost focus and text has 
% been changed or when press the "enter" key.
% As default, all events are deactivated, to activate must set the
% propertie 'have callback' from the properties editor

[ipMidH, ok] = str2num(get(selIpAddr.edIp2, 'String'));

if (ok)
  ipMidH = int32(ipMidH);
endif

if ((!ok) || (ipMidH < 0) || (ipMidH > 255)) 
  msgbox('The second part of address may be incorrect', 'Warning');
endif
end

## @deftypefn  {} {} edIp3_doIt (@var{src}, @var{data}, @var{selIpAddr})
##
## Define a callback for default action of edIp3 control.
##
## @end deftypefn
function edIp3_doIt(src, data, selIpAddr)

% This code will be executed when the control lost focus and text has 
% been changed or when press the "enter" key.
% As default, all events are deactivated, to activate must set the
% propertie 'have callback' from the properties editor

[ipMidL, ok] = str2num(get(selIpAddr.edIp3, 'String'));

if (ok)
  ipMidL = int32(ipMidL);
endif

if ((!ok) || (ipMidL < 0) || (ipMidL > 255)) 
  msgbox('The third part of address may be incorrect', 'Warning');
endif
end

## @deftypefn  {} {} edIp4_doIt (@var{src}, @var{data}, @var{selIpAddr})
##
## Define a callback for default action of edIp4 control.
##
## @end deftypefn
function edIp4_doIt(src, data, selIpAddr)

% This code will be executed when the control lost focus and text has 
% been changed or when press the "enter" key.
% As default, all events are deactivated, to activate must set the
% propertie 'have callback' from the properties editor

[ipLow, ok] = str2num(get(selIpAddr.edIp4, 'String'));

if (ok)
  ipLow = int32(ipLow);
endif

if ((!ok) || (ipLow < 0) || (ipLow > 255)) 
  msgbox('The last part of address may be incorrect', 'Warning');
endif
end

## @deftypefn  {} {} btnCancel_doIt (@var{src}, @var{data}, @var{selIpAddr})
##
## Define a callback for default action of btnCancel control.
##
## @end deftypefn
function btnCancel_doIt(src, data, selIpAddr)

% This code will be executed when user click the button control.
% As default, all events are deactivated, to activate must set the
% propertie 'have callback' from the properties editor

  close(selIpAddr.figure);
end

## @deftypefn  {} {} btnApply_doIt (@var{src}, @var{data}, @var{selIpAddr})
##
## Define a callback for default action of btnApply control.
##
## @end deftypefn
function btnApply_doIt(src, data, selIpAddr)

% This code will be executed when user click the button control.
% As default, all events are deactivated, to activate must set the
% propertie 'have callback' from the properties editor

  parentWnd = getappdata(selIpAddr.figure, "parentWnd");
  
  ipAddr = [get(selIpAddr.edIp1, 'String') "."];
  ipAddr = [ipAddr get(selIpAddr.edIp2, 'String') "."];
  ipAddr = [ipAddr get(selIpAddr.edIp3, 'String') "."];
  ipAddr = [ipAddr get(selIpAddr.edIp4, 'String')];

  setappdata(parentWnd, "ipAddr", ipAddr);  
  close(selIpAddr.figure);
end

 
## @deftypefn  {} {@var{ret} = } show_selIpAddr()
##
## Create windows controls over a figure, link controls with callbacks and return 
## a window struct representation.
##
## @end deftypefn
function ret = show_selIpAddr()
  _scrSize = get(0, "screensize");
  _xPos = (_scrSize(3) - 328)/2;
  _yPos = (_scrSize(4) - 120)/2;
   selIpAddr = figure ( ... 
	'Color', [0.937 0.922 0.906], ...
	'Position', [_xPos _yPos 328 120], ...
	'resize', 'off', ...
	'windowstyle', 'normal', ...
	'MenuBar', 'none');
  set(selIpAddr, 'visible', 'off');
  edIp1 = uicontrol( ...
	'parent',selIpAddr, ... 
	'Style','edit', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [1.000 1.000 1.000], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Ubuntu', ... 
	'FontSize', 11, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'center', ... 
	'Position', [60 48 43 22], ... 
	'String', '192', ... 
	'TooltipString', '');
  edIp2 = uicontrol( ...
	'parent',selIpAddr, ... 
	'Style','edit', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [1.000 1.000 1.000], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Ubuntu', ... 
	'FontSize', 11, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'center', ... 
	'Position', [115 48 43 22], ... 
	'String', '168', ... 
	'TooltipString', '');
  edIp3 = uicontrol( ...
	'parent',selIpAddr, ... 
	'Style','edit', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [1.000 1.000 1.000], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Ubuntu', ... 
	'FontSize', 11, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'center', ... 
	'Position', [170 48 43 22], ... 
	'String', '0', ... 
	'TooltipString', '');
  edIp4 = uicontrol( ...
	'parent',selIpAddr, ... 
	'Style','edit', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [1.000 1.000 1.000], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Ubuntu', ... 
	'FontSize', 11, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'center', ... 
	'Position', [225 48 43 22], ... 
	'String', '222', ... 
	'TooltipString', '');
  labTitle = uicontrol( ...
	'parent',selIpAddr, ... 
	'Style','text', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.937 0.922 0.906], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Ubuntu', ... 
	'FontSize', 11, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'center', ... 
	'Position', [12 88 305 17], ... 
	'String', 'Ip address for nodeMCU board:', ... 
	'TooltipString', '');
  btnCancel = uicontrol( ...
	'parent',selIpAddr, ... 
	'Style','pushbutton', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.937 0.922 0.906], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Ubuntu', ... 
	'FontSize', 11, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'Position', [12 13 90 22], ... 
	'String', 'Cancel', ... 
	'TooltipString', '');
  btnApply = uicontrol( ...
	'parent',selIpAddr, ... 
	'Style','pushbutton', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.937 0.922 0.906], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Ubuntu', ... 
	'FontSize', 11, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'Position', [227 13 90 22], ... 
	'String', 'Apply', ... 
	'TooltipString', '');

  selIpAddr = struct( ...
      'figure', selIpAddr, ...
      'edIp1', edIp1, ...
      'edIp2', edIp2, ...
      'edIp3', edIp3, ...
      'edIp4', edIp4, ...
      'labTitle', labTitle, ...
      'btnCancel', btnCancel, ...
      'btnApply', btnApply);


  set (edIp1, 'callback', {@edIp1_doIt, selIpAddr});
  set (edIp2, 'callback', {@edIp2_doIt, selIpAddr});
  set (edIp3, 'callback', {@edIp3_doIt, selIpAddr});
  set (edIp4, 'callback', {@edIp4_doIt, selIpAddr});
  set (btnCancel, 'callback', {@btnCancel_doIt, selIpAddr});
  set (btnApply, 'callback', {@btnApply_doIt, selIpAddr});
  dlg = struct(selIpAddr);
  set(selIpAddr.figure, 'visible', 'on');
%
% The source code writed here will be executed when
% windows load. Work like 'onLoad' event of other languages.
%

  ret = selIpAddr;
end

