#ifndef SETUPWIZARD_H
#define SETUPWIZARD_H
#include <QWizard>
#include <QObject>
#include <QWidget>
#include <QLabel>
#include <QComboBox>
#include <QPushButton>
#include <QCheckBox>
#include <configsettings.h>

class firstPage : public QWizardPage
{
    Q_OBJECT

public:
    firstPage(QWidget *parent, configSettings *appCfg);

private:
    QLabel *label;

protected:
    void initializePage();
};

class secondPage : public QWizardPage
{
    Q_OBJECT

public:
    secondPage(QWidget *parent, configSettings *appCfg);

private:
    QComboBox *cmbLanguage;
};

class thirdPage : public QWizardPage
{
    Q_OBJECT

public:
    thirdPage(QWidget *parent, configSettings *appCfg);

private:
    QLabel *topMsg;
    QLabel *octPath;
    QLabel *midMsg;
    QLabel *qtPlugPath;

    QPushButton *changeOctPath;
    QPushButton *changePlugPath;
    QPushButton *clearPlugPath;

private slots:
    void changeOctPath_click(bool checked);
    void changePlugPath_click(bool checked);
    void clearPlugPath_click(bool checked);
};

class fourthPage : public QWizardPage
{
    Q_OBJECT

public:
    fourthPage(QWidget *parent, configSettings *appCfg);

private:
    QLabel *topMsg;
    QLabel *gzipPath;
    QLabel *midMsg;
    QLabel *tarPath;

    QPushButton *changeGzipPath;
    QPushButton *changeTarPath;

private slots:
    void changeGzipPath_click(bool checked);
    void changeTarPath_click(bool checked);
};

class fifthPage : public QWizardPage
{
    Q_OBJECT

public:
    fifthPage(QWidget *parent, configSettings *appCfg);

private:
    QLabel *topMsg;
    QLabel *guiFName;
    QLabel *guiFSize;
    QLabel *midMsg;
    QLabel *srcFName;
    QLabel *srcFSize;

    QPushButton *changeGuiFont;
    QPushButton *changeSrcFont;

private slots:
    void changeGuiFont_click(bool checked);
    void changeSrcFont_click(bool checked);
};

class sixthPage : public QWizardPage
{
    Q_OBJECT

public:
    sixthPage(QWidget *parent, configSettings *appCfg);
private:
    QLabel *topMsg;
    QLabel *cmbTitle;
    QComboBox *outEncoding;
    QLabel *midMsg;
    QCheckBox *forceCodec;
};

class lastPage : public QWizardPage
{
    Q_OBJECT

public:
    lastPage(QWidget *parent, configSettings *appCfg);

private:
    QLabel *topMsg;
};

class setupWizard : public QWizard
{
private:
    configSettings *cfg;
public:
    setupWizard(configSettings *appCfg, QWidget *parent = 0);
    void accept(void);
};





#endif // SETUPWIZARD_H
