#include "versioncheck.h"
#include <QJsonDocument>
#include <QDebug>
#include "guiEditorVersion.h"
#include "mainwnd.h"

versionCheck::versionCheck(QObject *parent)
    : QObject{parent}
{
    netManager = new QNetworkAccessManager (this);
    connect(netManager, SIGNAL(finished(QNetworkReply*)), this, SLOT(managerFinished(QNetworkReply*)));
}

void versionCheck::managerFinished(QNetworkReply *reply){
    QString build;
    QString fecha;
    QString url;
    QString txt;
    QString descEn;
    QString descSp;
    if(!reply->error()){
        txt = reply->readAll();
        QJsonDocument jSon(QJsonDocument::fromJson(txt.toUtf8()));
        descEn = jSon["descEn"].toString();
        descSp = jSon["descSp"].toString();
        url =  jSon["url"].toString();
        build = jSon["build"].toString();
        fecha = build.mid(6, 2) + "/" + build.mid(4, 2) + "/" + build.mid(0, 4);
        if(build.toUInt() > QString(guiBuildDate).toUInt()){
            dlgNV.ui->labBuild->setText(build + " (" + fecha + ")");
            dlgNV.ui->labLink->setText("<a href='" + url + "'>" + url + "</a>" );
            dlgNV.ui->labLink->setTextFormat(Qt::RichText);
            dlgNV.ui->labLink->setTextInteractionFlags(Qt::TextBrowserInteraction);
            dlgNV.ui->labLink->setOpenExternalLinks(true);
            if(mainWnd::getAppConfig()->getLanguage() == "Spanish")
                dlgNV.ui->labDesc->setText(descSp);
            else
                dlgNV.ui->labDesc->setText(descEn);
            dlgNV.exec();
        }
    }
}

void versionCheck::doCheck(void){
    request.setUrl(QUrl("https://guieditor.net.ar/lastest/v3/release.php"));
    netManager->get(request);
}

versionCheck::~versionCheck(void){
    delete netManager;
}
