#include "wdgproject.h"
#include "ui_wdgproject.h"
#include "guiproject.h"
#include <QDebug>

void wdgProject::resizeEvent(QResizeEvent *event){
    QList <int> newWidths;
    QWidget::resizeEvent(event);
    newWidths.push_back(this->width()*.2);
    newWidths.push_back(this->width()*.8);
    this->ui->splitter->setSizes(newWidths);
}

wdgProject::wdgProject(guiProject * prj, QWidget *parent) :
    QWidget(parent),
    ui(new Ui::wdgProject)
{
    ui->setupUi(this);
    ui->docTabs->setTabsClosable(true);
    this->guiPrj = prj;
    ui->docTabs->setDocumentMode(true);
}

void wdgProject::updateTreeNames(bool openFirst){
    treeItemGroup * firstLevel;
    abstractPrjTreeItem  * mustOpen=nullptr;
    QStringList listHeaders;
    QList<projectItem *>::iterator it;
    this->ui->prjItems->clear();
    for(it = this->guiPrj->items.begin(); it != this->guiPrj->items.end(); it++){
        if(!listHeaders.contains((*it)->groupName()))
            listHeaders.append((*it)->groupName());
    }

    for(int k = 0; k < listHeaders.count(); k++){
        firstLevel = new treeItemGroup(this->guiPrj, this->ui->prjItems);
        firstLevel->setText(0, listHeaders[k]);
        for(it = this->guiPrj->items.begin(); it != this->guiPrj->items.end(); it++){
            if(listHeaders[k] == (*it)->groupName()){
                if((mustOpen == nullptr) && (openFirst)){
                    mustOpen = (*it)->treeItemWidget(firstLevel);
                    mustOpen->activate();
                }
                else{
                    (*it)->treeItemWidget(firstLevel);
                }

            }
        }
        this->ui->prjItems->addTopLevelItem(firstLevel);
        firstLevel->setExpanded(true);
    }
}

wdgProject::~wdgProject()
{
    delete ui;
}


void wdgProject::on_prjItems_itemActivated(QTreeWidgetItem *item, int column __attribute__((unused)))
{
    if(item){
        dynamic_cast<abstractPrjTreeItem *>(item)->activate();
    }
}

void wdgProject::on_docTabs_tabCloseRequested(int index)
{
    ui->docTabs->removeTab(index);
    //delete ui->docTabs->widget(index);
}
