#include "wdgtblbackcolorchooser.h"
#include "ui_wdgtblbackcolorchooser.h"
#include <QColorDialog>

wdgTblBackColorChooser::wdgTblBackColorChooser(abstractPropEditor * prop) :
    QWidget(0),updPropWdg(prop),
    ui(new Ui::wdgTblBackColorChooser)
{
    ui->setupUi(this);
}

wdgTblBackColorChooser::~wdgTblBackColorChooser()
{
    delete ui;
}

void wdgTblBackColorChooser::on_btnFirstColor_clicked()
{
    QColor clr;
    QColor ret;
    QString fullVal, tmp;
    QString strColor = ui->leFirstColor->text();
    strColor.remove("[");
    strColor.remove("]");
    QStringList v = strColor.split(" ");
    if(v.count() == 3)
        clr = QColor::fromRgbF(v[0].toFloat(), v[1].toFloat(), v[2].toFloat());
    else
        clr = Qt::black;
    ret = QColorDialog::getColor(clr, this, "Select first color...");
    if(ret.isValid())
    {
        strColor = "[";
        strColor += QString::number(ret.redF(), 'f', 3) + " ";
        strColor += QString::number(ret.greenF(), 'f', 3) + " ";
        strColor += QString::number(ret.blueF(), 'f', 3) + "]";
        ui->leFirstColor->setText(strColor);
    }
    fullVal = ui->leFirstColor->text();
    fullVal.remove("]");
    fullVal = fullVal + ";";
    tmp = ui->leSecondColor->text();
    tmp.remove("[");
    fullVal = fullVal + tmp;
    this->getPropEditor()->setValue(fullVal);
}

void wdgTblBackColorChooser::setColors(QString v){
    QStringList clrs = v.split(";");
    ui->leFirstColor->setText(clrs[0] + "]");
    ui->leSecondColor->setText("[" + clrs[1]);
}

QString wdgTblBackColorChooser::getColors(){
    QString ret;
    QString temp;
    temp = ui->leFirstColor->text();
    temp.remove("]");
    ret = temp + ";";
    temp = ui->leSecondColor->text();
    temp.remove("[");
    ret = ret + temp;
    return ret;
}

QLineEdit *wdgTblBackColorChooser::getFirstLEColor(){
    return ui->leFirstColor;
}

QLineEdit *wdgTblBackColorChooser::getSecondLEColor(){
    return ui->leSecondColor;
}

void wdgTblBackColorChooser::updPropValue()
{
    QStringList clrs = this->getPropEditor()->getValue().split(";");

    ui->leFirstColor->setText(clrs[0] + "]");
    ui->leSecondColor->setText("[" + clrs[1]);
}

void wdgTblBackColorChooser::on_btnSecondColor_clicked()
{
    QColor clr;
    QColor ret;
    QString fullVal;
    QString tmp;
    QString strColor = ui->leSecondColor->text();
    strColor.remove("[");
    strColor.remove("]");
    QStringList v = strColor.split(" ");
    if(v.count() == 3)
        clr = QColor::fromRgbF(v[0].toFloat(), v[1].toFloat(), v[2].toFloat());
    else
        clr = Qt::black;
    ret = QColorDialog::getColor(clr, this, "Select second color...");
    if(ret.isValid())
    {
        strColor = "[";
        strColor += QString::number(ret.redF(), 'f', 3) + " ";
        strColor += QString::number(ret.greenF(), 'f', 3) + " ";
        strColor += QString::number(ret.blueF(), 'f', 3) + "]";
        ui->leSecondColor->setText(strColor);
    }
    fullVal = ui->leFirstColor->text();
    fullVal.remove("]");
    fullVal = fullVal + ";";
    tmp = ui->leSecondColor->text();
    tmp.remove("[");
    fullVal = fullVal + tmp;
    this->getPropEditor()->setValue(fullVal);
}

